/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package display;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.Vector;

import javax.swing.JFrame;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.DeviationRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYIntervalSeries;
import org.jfree.data.xy.XYIntervalSeriesCollection;

@SuppressWarnings("serial")
public class CTLineDeviationChart extends JFrame {

	public CTLineDeviationChart(String applicationTitle, String axis, Color color, Vector<Point2D.Double> data, Vector<Point2D.Double> std) {
        super(applicationTitle);
        XYDataset dataSet = getData(data, std);
        JFreeChart chart = ChartFactory.createXYLineChart(null,"Frame",axis,dataSet,PlotOrientation.VERTICAL,false,false,false);
        XYPlot plot = (XYPlot) chart.getPlot();
        DeviationRenderer renderer = new DeviationRenderer();
        renderer.setSeriesLinesVisible(0, true);
        renderer.setSeriesShapesVisible(0, true);
        renderer.setSeriesPaint(0, color);
        renderer.setSeriesFillPaint(0, color); 
        plot.setRenderer(renderer);
        final ChartPanel chartPanel = new ChartPanel(chart);
        setContentPane(chartPanel);
    }
    
    private static XYDataset getData(Vector<Point2D.Double> data, Vector<Point2D.Double> std) {
    	XYIntervalSeries series = new XYIntervalSeries("");
    	int length = data.size();
    	for(int i=0; i<length; i++){
	        series.add(data.elementAt(i).x,data.elementAt(i).x, data.elementAt(i).x, data.elementAt(i).y, data.elementAt(i).y-std.elementAt(i).y, data.elementAt(i).y+std.elementAt(i).y);
		}
		
		XYIntervalSeriesCollection dataSet = new XYIntervalSeriesCollection();
        dataSet.addSeries(series);
        return dataSet;
	}
}