/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package structures;

import java.util.Vector;

public class CTUnsortedPairSortedList {
	private Vector<CTUnsortedPair> set = null;
	
	public CTUnsortedPairSortedList(){
		set = new Vector<CTUnsortedPair>();
	}
	
	public int size(){
		return set.size();
	}
	
	public boolean isEmpty(){
		return set.isEmpty();
	}
	
	public void addElement(int i, int j){
		CTUnsortedPair element = new CTUnsortedPair(i,j);
		if(!contains(element)){
			set.addElement(element);
		}
	}
	
	public int minElementAt(int index){
		return set.elementAt(index).getMin();
	}

	public int maxElementAt(int index){
		return set.elementAt(index).getMax();
	}

	
	public void removeElementAt(int index){
		set.removeElementAt(index);
	}
	
	public boolean contains(CTUnsortedPair element){
		boolean found = false;
		int size = set.size();
		int max = element.getMax();
		int min = element.getMin();
		for(int i=0; i<size && !found; i++){
			found = (set.elementAt(i).getMax()==max) && (set.elementAt(i).getMin()==min);
		}
		return found;
	}
	
}
