/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
import ij.IJ;
import ij.gui.GUI;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;

@SuppressWarnings("serial")
public class CTCredits extends JDialog implements ActionListener {

	private JButton bnClose = new JButton("Close");
	private GridBagLayout 		layout			= new GridBagLayout();;
	private GridBagConstraints 	constraint		= new GridBagConstraints();

	public CTCredits(JFrame parentWindow) {
		super(parentWindow, "Credits");
		setModal(true);
		JTextArea credits = new JTextArea(20, 30);
		credits.append(" Ricard Delgado-Gonzalo\n");
		credits.append(" \n");
		credits.append(" EPFL/STI/IMT/LIB\n");
		credits.append(" BM 4.141\n");
		credits.append(" Station 17\n");
		credits.append(" CH-1015 Lausanne VD\n");
		credits.append(" Switzerland\n");
		credits.append(" \n");
		credits.append(" E-mail: ricard.delgado@epfl.ch\n");
		credits.append(" URL: http://bigwww.epfl.ch/delgado/\n");
		credits.append(" \n");
		credits.append(" Copyright Free:\n");
		credits.append(" \n");
		credits.append(" You'll be free to use this software for research purposes,\n");
		credits.append(" but you should not redistribute it without our consent.\n");
		credits.append(" In addition, you undertake to include a citation or\n");
		credits.append(" acknowledgment whenever you present or publish results\n");
		credits.append(" that are based on it. EPFL makes no warranties of any\n");
		credits.append(" kind on this software and shall in no event be liable for\n"); 
		credits.append(" damages of any kind in connection with the use and exploitation\n");
		credits.append(" of this technology.");
		credits.setForeground(new Color(0, 32, 128));
		credits.setBackground(this.getBackground());

		JPanel panelCredits = new JPanel();
		panelCredits.setLayout(layout);
		addComponent(panelCredits, 0, 0, 8, 1, 9, credits);
		panelCredits.setBorder(BorderFactory.createEtchedBorder());
	
		// Add Listeners
		bnClose.addActionListener(this);
		
		JPanel panel = new JPanel();
		panel.setLayout(layout);
		addComponent(panel, 0, 0, 8, 1, 9, panelCredits);
		addComponent(panel, 1, 0, 1, 1, 9, new JLabel("  "));
		addComponent(panel, 1, 4, 1, 1, 9, bnClose);
		addComponent(panel, 1, 5, 1, 1, 9, new JLabel("  "));
	
		// Building the main panel
		setLayout(layout);
		JPanel pnMain = new JPanel();
		pnMain.setLayout(layout);
		addComponent(pnMain, 0, 0, 1, 1, 9, panel);
		add(pnMain);
		pack();
		setResizable(false);
		GUI.center(this);
		setVisible(true);
	}
	
	/**
	 * Add a component in a panel in the northeast of the cell.
	 */
	private void addComponent(JPanel pn, int row, final int col, int width, final int height, int space, JComponent comp) {
		constraint.gridx = col;
		constraint.gridy = row;
		constraint.gridwidth = width;
		constraint.gridheight = height;
		constraint.anchor = GridBagConstraints.NORTHWEST;
		constraint.insets = new Insets(space, space, space, space);
		constraint.weightx = IJ.isMacintosh()?90:100;
		constraint.fill = GridBagConstraints.HORIZONTAL;
		layout.setConstraints(comp, constraint);
		pn.add(comp);
	}

	/**
	 * Implements the actionPerformed for the ActionListener.
	 */
	public synchronized  void actionPerformed(ActionEvent e) {
		if (e.getSource() == bnClose) {
			dispose();
		}
		notify();
	}

}

